> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Share Resource With Principal

> Shares a resource directly with a principal (user or service account).

`Unary` · [`Groups`](https://ona.com/docs/api-reference/generated/group/overview)

Shares a resource directly with a principal (user or service account).

Use this method to:

* Grant a user or service account direct access to a runner, project, or other resource
* Share resources without creating and managing groups manually

### Examples

* Share a runner with a user:

  Grants admin access to a runner for a specific user.

  ```yaml theme={null}
  resourceType: RESOURCE_TYPE_RUNNER
  resourceId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  principal: PRINCIPAL_USER
  principalId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  role: RESOURCE_ROLE_RUNNER_ADMIN
  ```

* Share a runner with a service account:

  Grants user access to a runner for a service account.

  ```yaml theme={null}
  resourceType: RESOURCE_TYPE_RUNNER
  resourceId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  principal: PRINCIPAL_SERVICE_ACCOUNT
  principalId: "a1b2c3d4-5678-90ab-cdef-1234567890ab"
  role: RESOURCE_ROLE_RUNNER_USER
  ```

### Authorization

Requires admin role on the specific resource.

## Endpoint

```text theme={null}
POST /api/gitpod.v1.GroupService/ShareResourceWithPrincipal
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.GroupService/ShareResourceWithPrincipal" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "resourceType": "RESOURCE_TYPE_ENVIRONMENT"
}'
```

```python Python theme={null}
import gitpod.v1.event_pb2 as event_pb2
import gitpod.v1.group_pb2 as group_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = group_pb2.ShareResourceWithPrincipalRequest(
    resource_type=event_pb2.RESOURCE_TYPE_ENVIRONMENT,
)
response = ona.services.group.share_resource_with_principal(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { ResourceType } from "@gitpod/sdk/gitpod/v1/event_pb";
import { ShareResourceWithPrincipalRequestSchema } from "@gitpod/sdk/gitpod/v1/group_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(ShareResourceWithPrincipalRequestSchema, {
    resourceType: ResourceType.ENVIRONMENT,
  });
  const response = await ona.services.group.shareResourceWithPrincipal(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.ShareResourceWithPrincipalRequest{
		ResourceType: gitpodpb.ResourceType_RESOURCE_TYPE_ENVIRONMENT,
	})
	response, err := ona.Services.Group.ShareResourceWithPrincipal(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "resourceType": "RESOURCE_TYPE_ENVIRONMENT"
}
```

## Request

`gitpod.v1.ShareResourceWithPrincipalRequest`

ShareResourceWithPrincipal messages

| Field | Type | Required | Description |
| - | - | - | - |
| `resourceType` | [ResourceType](#enum-gitpod-v1-resource-type) | No | Type of resource to share (runner, project, etc.) Constraints: `enum.defined_only=true, enum.not_in=0`. |
| `resourceId` | string | No | ID of the resource to share Constraints: `string.uuid=true`. |
| `principal` | [Principal](#enum-gitpod-v1-principal) | No | Type of principal to share with (user or service account) Constraints: `enum.defined_only=true, enum.in=2, enum.in=5`. |
| `principalId` | string | No | ID of the principal (user or service account) to share with Constraints: `string.uuid=true`. |
| `role` | [ResourceRole](#enum-gitpod-v1-resource-role) | No | Role to grant the principal on the resource Constraints: `enum.defined_only=true, enum.not_in=0`. |

## Response

`gitpod.v1.ShareResourceWithPrincipalResponse`

This message has no fields.

## Related types

> [accordion] Principal
>
> | Value | Number | Description |
> | - | -: | - |
> | `PRINCIPAL_UNSPECIFIED` | 0 | |
> | `PRINCIPAL_ACCOUNT` | 1 | |
> | `PRINCIPAL_USER` | 2 | |
> | `PRINCIPAL_RUNNER` | 3 | |
> | `PRINCIPAL_ENVIRONMENT` | 4 | |
> | `PRINCIPAL_SERVICE_ACCOUNT` | 5 | |
> | `PRINCIPAL_RUNNER_MANAGER` | 6 | |

> [accordion] ResourceRole
>
> ResourceRole represents roles that can be assigned to groups on resources
> These map directly to the roles defined in backend/db/rule/rbac/role/role.go
>
> | Value | Number | Description |
> | - | -: | - |
> | `RESOURCE_ROLE_UNSPECIFIED` | 0 | |
> | `RESOURCE_ROLE_ORG_ADMIN` | 1 | Organization roles |
> | `RESOURCE_ROLE_ORG_MEMBER` | 2 | |
> | `RESOURCE_ROLE_ORG_RUNNERS_ADMIN` | 50 | |
> | `RESOURCE_ROLE_ORG_PROJECTS_ADMIN` | 51 | |
> | `RESOURCE_ROLE_ORG_AUTOMATIONS_ADMIN` | 52 | |
> | `RESOURCE_ROLE_ORG_GROUPS_ADMIN` | 53 | |
> | `RESOURCE_ROLE_ORG_ENVIRONMENTS_READER` | 66 | |
> | `RESOURCE_ROLE_ORG_AUDIT_LOG_READER` | 64 | |
> | `RESOURCE_ROLE_ORG_BILLING_VIEWER` | 67 | |
> | `RESOURCE_ROLE_ORG_INSIGHTS_VIEWER` | 68 | |
> | `RESOURCE_ROLE_ORG_SECURITY_ADMIN` | 69 | |
> | `RESOURCE_ROLE_ORG_DEFENCE_FACTORY_ADMIN` | 72 | |
> | `RESOURCE_ROLE_GROUP_ADMIN` | 3 | Group roles |
> | `RESOURCE_ROLE_GROUP_VIEWER` | 4 | |
> | `RESOURCE_ROLE_USER_IDENTITY` | 5 | User roles |
> | `RESOURCE_ROLE_USER_VIEWER` | 6 | |
> | `RESOURCE_ROLE_USER_ADMIN` | 7 | |
> | `RESOURCE_ROLE_ENVIRONMENT_IDENTITY` | 8 | Environment roles |
> | `RESOURCE_ROLE_ENVIRONMENT_ADMIN` | 9 | |
> | `RESOURCE_ROLE_ENVIRONMENT_USER` | 10 | |
> | `RESOURCE_ROLE_ENVIRONMENT_VIEWER` | 11 | |
> | `RESOURCE_ROLE_ENVIRONMENT_RUNNER` | 12 | |
> | `RESOURCE_ROLE_RUNNER_IDENTITY` | 13 | Runner roles |
> | `RESOURCE_ROLE_RUNNER_ADMIN` | 14 | |
> | `RESOURCE_ROLE_RUNNER_LOCAL_ADMIN` | 15 | |
> | `RESOURCE_ROLE_RUNNER_MANAGED_ADMIN` | 16 | |
> | `RESOURCE_ROLE_RUNNER_USER` | 17 | |
> | `RESOURCE_ROLE_RUNNER_CONFIGURATION_READER` | 18 | |
> | `RESOURCE_ROLE_HOST_AUTHENTICATION_TOKEN_ADMIN` | 19 | Host authentication token roles |
> | `RESOURCE_ROLE_HOST_AUTHENTICATION_TOKEN_UPDATER` | 20 | |
> | `RESOURCE_ROLE_PROJECT_ADMIN` | 21 | Project roles |
> | `RESOURCE_ROLE_PROJECT_USER` | 22 | |
> | `RESOURCE_ROLE_PROJECT_EDITOR` | 23 | |
> | `RESOURCE_ROLE_ENVIRONMENT_SERVICE_ADMIN` | 24 | Environment service roles |
> | `RESOURCE_ROLE_ENVIRONMENT_SERVICE_VIEWER` | 25 | |
> | `RESOURCE_ROLE_ENVIRONMENT_SERVICE_USER` | 26 | |
> | `RESOURCE_ROLE_ENVIRONMENT_SERVICE_ENV` | 27 | |
> | `RESOURCE_ROLE_ENVIRONMENT_TASK_ADMIN` | 28 | Environment task roles |
> | `RESOURCE_ROLE_ENVIRONMENT_TASK_VIEWER` | 29 | |
> | `RESOURCE_ROLE_ENVIRONMENT_TASK_USER` | 30 | |
> | `RESOURCE_ROLE_ENVIRONMENT_TASK_ENV` | 31 | |
> | `RESOURCE_ROLE_SERVICE_ACCOUNT_IDENTITY` | 32 | Service account roles |
> | `RESOURCE_ROLE_SERVICE_ACCOUNT_ADMIN` | 33 | |
> | `RESOURCE_ROLE_AGENT_EXECUTION_USER` | 35 | |
> | `RESOURCE_ROLE_AGENT_EXECUTION_ADMIN` | 36 | |
> | `RESOURCE_ROLE_AGENT_EXECUTION_RUNNER` | 37 | |
> | `RESOURCE_ROLE_AGENT_EXECUTION_OUTPUTS_REPORTER` | 46 | |
> | `RESOURCE_ROLE_AGENT_EXECUTION_VIEWER` | 65 | |
> | `RESOURCE_ROLE_AGENT_ADMIN` | 38 | Agent roles |
> | `RESOURCE_ROLE_AGENT_VIEWER` | 39 | |
> | `RESOURCE_ROLE_AGENT_EXECUTOR` | 40 | |
> | `RESOURCE_ROLE_WORKFLOW_ADMIN` | 41 | Workflow roles |
> | `RESOURCE_ROLE_WORKFLOW_USER` | 42 | |
> | `RESOURCE_ROLE_WORKFLOW_VIEWER` | 43 | |
> | `RESOURCE_ROLE_WORKFLOW_EXECUTOR` | 47 | |
> | `RESOURCE_ROLE_SNAPSHOT_ADMIN` | 44 | Snapshot roles |
> | `RESOURCE_ROLE_SNAPSHOT_RUNNER` | 45 | |
> | `RESOURCE_ROLE_WEBHOOK_ADMIN` | 48 | Webhook roles |
> | `RESOURCE_ROLE_WEBHOOK_VIEWER` | 49 | |
> | `RESOURCE_ROLE_WARMPOOL_RUNNER` | 54 | |
> | `RESOURCE_ROLE_WARMPOOL_ADMIN` | 55 | |
> | `RESOURCE_ROLE_WARMPOOL_VIEWER` | 56 | |
> | `RESOURCE_ROLE_SESSION_ADMIN` | 60 | Session roles |
> | `RESOURCE_ROLE_SESSION_USER` | 61 | |
> | `RESOURCE_ROLE_TEAM_ADMIN` | 62 | |
> | `RESOURCE_ROLE_TEAM_VIEWER` | 63 | |
> | `RESOURCE_ROLE_SECURITY_POLICY_ADMIN` | 70 | |
> | `RESOURCE_ROLE_SECURITY_POLICY_VIEWER` | 71 | |

> [accordion] ResourceType
>
> | Value | Number | Description |
> | - | -: | - |
> | `RESOURCE_TYPE_UNSPECIFIED` | 0 | |
> | `RESOURCE_TYPE_ENVIRONMENT` | 1 | |
> | `RESOURCE_TYPE_RUNNER` | 2 | |
> | `RESOURCE_TYPE_PROJECT` | 3 | |
> | `RESOURCE_TYPE_TASK` | 4 | |
> | `RESOURCE_TYPE_TASK_EXECUTION` | 5 | |
> | `RESOURCE_TYPE_SERVICE` | 6 | |
> | `RESOURCE_TYPE_ORGANIZATION` | 7 | |
> | `RESOURCE_TYPE_USER` | 8 | |
> | `RESOURCE_TYPE_ENVIRONMENT_CLASS` | 9 | |
> | `RESOURCE_TYPE_RUNNER_SCM_INTEGRATION` | 10 | |
> | `RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN` | 11 | |
> | `RESOURCE_TYPE_GROUP` | 12 | |
> | `RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN` | 13 | |
> | `RESOURCE_TYPE_USER_PREFERENCE` | 14 | |
> | `RESOURCE_TYPE_SERVICE_ACCOUNT` | 15 | |
> | `RESOURCE_TYPE_SECRET` | 16 | |
> | `RESOURCE_TYPE_SSO_CONFIG` | 17 | |
> | `RESOURCE_TYPE_DOMAIN_VERIFICATION` | 18 | |
> | `RESOURCE_TYPE_AGENT_EXECUTION` | 19 | |
> | `RESOURCE_TYPE_RUNNER_LLM_INTEGRATION` | 20 | |
> | `RESOURCE_TYPE_AGENT` | 21 | |
> | `RESOURCE_TYPE_ENVIRONMENT_SESSION` | 22 | |
> | `RESOURCE_TYPE_USER_SECRET` | 23 | |
> | `RESOURCE_TYPE_ORGANIZATION_POLICY` | 24 | |
> | `RESOURCE_TYPE_ORGANIZATION_SECRET` | 25 | |
> | `RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS` | 26 | |
> | `RESOURCE_TYPE_BILLING` | 27 | |
> | `RESOURCE_TYPE_PROMPT` | 28 | |
> | `RESOURCE_TYPE_COUPON` | 29 | |
> | `RESOURCE_TYPE_COUPON_REDEMPTION` | 30 | |
> | `RESOURCE_TYPE_ACCOUNT` | 31 | |
> | `RESOURCE_TYPE_INTEGRATION` | 32 | |
> | `RESOURCE_TYPE_WORKFLOW` | 33 | |
> | `RESOURCE_TYPE_WORKFLOW_EXECUTION` | 34 | |
> | `RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION` | 35 | |
> | `RESOURCE_TYPE_SNAPSHOT` | 36 | |
> | `RESOURCE_TYPE_PREBUILD` | 37 | |
> | `RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION` | 38 | |
> | `RESOURCE_TYPE_CUSTOM_DOMAIN` | 39 | |
> | `RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED` | 40 | |
> | `RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED` | 41 | |
> | `RESOURCE_TYPE_WEBHOOK` | 42 | |
> | `RESOURCE_TYPE_SCIM_CONFIGURATION` | 43 | |
> | `RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET` | 44 | |
> | `RESOURCE_TYPE_ANNOUNCEMENT_BANNER` | 45 | |
> | `RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN` | 46 | |
> | `RESOURCE_TYPE_ROLE_ASSIGNMENT` | 47 | |
> | `RESOURCE_TYPE_WARM_POOL` | 48 | |
> | `RESOURCE_TYPE_NOTIFICATION` | 49 | |
> | `RESOURCE_TYPE_SECURITY_POLICY` | 50 | |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.